VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTileGroup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private lngWidth As Long
Private lngHeight As Long
Private lngTile() As Long
Private strName As String


' Note: Function always succeeds (return value 0)
Public Function ReadTileGroup(lngFileNum As Long) As Long
    Dim stringLength As Long

    ' Read in the tile group dimensions
    Get #lngFileNum, , lngWidth
    Get #lngFileNum, , lngHeight

    ' Allocate space for the tile array
    ReDim lngTile(lngWidth * lngHeight - 1)

    ' Read in the tile data for this group
    Get #lngFileNum, , lngTile()

    ' Read in the name of this tile group
    Get #lngFileNum, , stringLength
    strName = Space$(stringLength)
    Get #lngFileNum, , strName
End Function

' Note: Function always succeeds (return value 0)
Public Function WriteTileGroup(lngFileNum As Long) As Long
    ' Write the tile group data
    Put #lngFileNum, , lngWidth
    Put #lngFileNum, , lngHeight
    Put #lngFileNum, , lngTile()
    Put #lngFileNum, , Len(strName)
    Put #lngFileNum, , strName
End Function

Public Sub SetDimensions(newWidth As Long, newHeight As Long)
    Dim lngSize As Long

    ' Check if array size needs adjustment
    lngSize = newWidth * newHeight
    If lngSize <> lngWidth * lngHeight Then
        ' We need more storage space
        ReDim Preserve lngTile(lngSize - 1)
    End If

    ' Set the new dimensions
    lngWidth = newWidth
    lngHeight = newHeight
End Sub

Public Property Get Width() As Long
    Width = lngWidth
End Property

Public Property Get Height() As Long
    Height = lngHeight
End Property

Public Property Get Tile(x As Long, y As Long) As Long
    ' Error check coordinates
    If x < 0 Or x >= Width Or y < 0 Or y >= Height Then
        ' Invalid coordinates. Return -1
        Tile = -1
        Exit Function
    End If

    ' Return the tile
    Tile = lngTile(y * Width + x)
End Property

Public Property Get Name() As String
    Name = strName
End Property

Public Property Let Name(newName As String)
    strName = newName
End Property

