VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTileSet"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' Note: This class needs a LOT of work. It doesn't load palettes properly or
' handle multiple data sections. Error checking is nonexistent. Determining
' end of file is missing.
' ... but, it seems to work with existing data, even if it's not code equivalent


Private Type typSectionHeader
    tag As String * 4
    length As Long
End Type

Private Type typHeaderData
    numSections As Long
    unknown1 As Long
    unknown2 As Long
    unknown3 As Long
    unknown4 As Long
End Type


Private udtHeaderData As typHeaderData
Private data() As Byte
Private lngDataLen As Long
Private lngNumTiles As Long
Private bmPasteInfo As BITMAPINFO


Public Function OpenFile(strFileName As String) As Long
    Dim lngFileNum As Long

    ' Check if the file exists
    If Len(Dir(strFileName)) = 0 Then
        ' Error, file doesn't exist
        OpenFile = -1
        Exit Function
    End If
    
    ' Open the file
    lngFileNum = FreeFile
    Open strFileName For Binary As #lngFileNum

    ' Check file size
    If LOF(lngFileNum) <= 0 Then
        ' Error, file is empty
        Close #lngFileNum
        OpenFile = -1
        Exit Function
    End If
    
    ' Read the file data
    OpenFile = ReadWellData(lngFileNum)

    ' Close the file
    Close #lngFileNum
End Function

Public Function ReadWellData(lngFileNum As Long)
    Dim udtSectHead As typSectionHeader
    Dim lngNumSections As Long

    ' Read all tags
    lngNumSections = -2
    Do
        ' Read the section tag
        Get #lngFileNum, , udtSectHead
        
        ' Check for bitmap header
        If Left$(udtSectHead.tag, 2) = "BM" Then
            ' Ignore for now
            ' **TODO** look into this someday
            ReadWellData = -1
            Exit Function
        End If
        
        ' Determine which type of section to read
        Select Case udtSectHead.tag
            Case "PBMP"
                ' Not really anything to do but keep reading tags (subsections?)
            Case "PPAL"
                ' Read subsections
                ' **TODO** fix following cheap hack. It should really loop and
                ' handle tags much like the outer loop.
                ' **Note: A CPalette class has since been designed that could be
                ' used here.
                Get #lngFileNum, , udtSectHead
                Get #lngFileNum, , lngNumSections
                ' Read palette data section
                Get #lngFileNum, , udtSectHead
                Get #lngFileNum, , bmPasteInfo.bmiColors
            Case "data"
                ' Read the data
                lngDataLen = udtSectHead.length
                lngNumTiles = lngDataLen \ 1024
                ReDim data(lngDataLen - 1)
                Get #lngFileNum, , data
            Case "head"
                ' Read in the header info
                ' **NOTE** Techinically, this is a cheap hack and should read how much
                ' is specified by the section length, but it should always work with
                ' the standard files
                Get #lngFileNum, , udtHeaderData
                lngNumSections = udtHeaderData.numSections
            Case Else
                ' Ignore for now, shouldn't happen
                ' **TODO** proper error handling someday
                ReadWellData = -1
                Exit Function
        End Select
        lngNumSections = lngNumSections - 1
    Loop While lngNumSections <> -1

    ' Setup bitmap header structure needed for pasting
    With bmPasteInfo.bmiHeader
        .biSize = Len(bmPasteInfo.bmiHeader)
        .biBitCount = 8
        .biWidth = 32
        .biHeight = -32
        .biPlanes = 1
        .biCompression = BI_RGB
    End With
    
    Dim i As Long
    Dim t As Long
    For i = 0 To 255
        With bmPasteInfo.bmiColors(i)
            t = .rgbBlue
            .rgbBlue = .rgbRed
            .rgbRed = t
        End With
    Next i

    ' Return success
    ReadWellData = 0
End Function


Public Property Get NumTiles() As Long
    NumTiles = lngNumTiles
End Property

Public Function Paste(destDC As Long, x As Long, y As Long, lngTile As Long) As Long
    ' Error check tile index
    If lngTile < 0 Or lngTile >= lngNumTiles Then Exit Function
    ' Paste the tile
    Paste = SetDIBitsToDevice(destDC, x, y, 32, 32, 0, 0, 0, 32, data(lngTile * 1024), bmPasteInfo, DIB_RGB_COLORS)
End Function



Public Property Get PixelData(tileIndex As Long, k As Long) As Long
    PixelData = data(tileIndex * 1024 + k)
End Property

Public Property Let PixelData(tileIndex As Long, k As Long, newData As Long)
    data(tileIndex * 1024 + k) = newData
End Property

Public Property Get PalEntry(index As Long) As Long
    With bmPasteInfo.bmiColors(index)
        PalEntry = .rgbBlue + (.rgbGreen * 256&) + (.rgbRed * 65536)
    End With
End Property
