VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTileSetList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private oTileSet() As New CTileSet
Private numTilesSoFar() As Long
Private lngNumTileSets As Long
Private lngNumTilesTotal As Long


' Return value: the number of successfully loaded tile sets
Public Function LoadTileSets(strPath As String, numTileSetsToLoad As Long)
    Dim i As Long
    Dim lngRetVal As Long

    ' Allocate space to hold the tile sets
    ReDim oTileSet(numTileSetsToLoad)
    ReDim numTilesSoFar(numTileSetsToLoad + 1)

    ' Load all the tile sets
    For i = 0 To numTileSetsToLoad - 1
        ' Load the tile set
        lngRetVal = oTileSet(i).OpenFile(strPath + "well" + Format$(i, "0000") + ".bmp")
        ' Check for errors
        If lngRetVal <> 0 Then
            ' Error. Return number of successfully loaded tile sets
            lngNumTileSets = i
            LoadTileSets = lngNumTileSets
            Exit Function
        End If

        ' Update the count of tiles
        numTilesSoFar(i + 1) = numTilesSoFar(i) + oTileSet(i).NumTiles
    Next i

    ' Store the total number of loaded tiles
    lngNumTilesTotal = numTilesSoFar(numTileSetsToLoad)

    ' Set the number of loaded tile sets
    lngNumTileSets = numTileSetsToLoad
    ' Return success
    LoadTileSets = lngNumTileSets
End Function


Public Property Get NumTileSets() As Long
    NumTileSets = lngNumTileSets
End Property

Public Property Get NumTilesTotal() As Long
    NumTilesTotal = lngNumTilesTotal
End Property

Public Property Get TileSet(index As Long) As CTileSet
    ' Error check the index
    If index < 0 Or index >= lngNumTileSets Then
        ' Invalid index. Return Null.
        Exit Property
    End If

    ' Return the tile set
    Set TileSet = oTileSet(index)
End Property

' Returns the number of tiles in the tile sets up to, but not including the given tile set
Public Property Get NumTilesUpTo(index As Long) As Long
    ' Error check the index
    If index < 0 Or index >= lngNumTileSets Then
        ' Invalid index. Return Null.
        Exit Property
    End If

    ' Return the number of tiles up to this tile set
    NumTilesUpTo = numTilesSoFar(index)
End Property


Public Function TileSetIndexOfTile(tileIndex As Long) As Long
    Dim i As Long

    ' Find what tile set this tile is in
    For i = lngNumTileSets - 1 To 0 Step -1
        ' Check if this tile is in this tile set
        If numTilesSoFar(i) <= tileIndex Then
            ' Return the tile set index
            TileSetIndexOfTile = i
            Exit Function
        End If
    Next i
End Function

