VERSION 5.00
Begin VB.Form frmTerrainTypes 
   Caption         =   "Terrain Types"
   ClientHeight    =   11880
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   16710
   LinkTopic       =   "Form1"
   ScaleHeight     =   11880
   ScaleWidth      =   16710
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fmeTileChooser 
      Caption         =   "Tile Chooser"
      Height          =   11775
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1935
      Begin VB.ListBox lstTileGroups 
         Height          =   9225
         Left            =   240
         TabIndex        =   4
         Top             =   2280
         Width           =   1455
      End
      Begin VB.ListBox lstTerrainType 
         Height          =   1425
         ItemData        =   "frmTerrainTypes.frx":0000
         Left            =   240
         List            =   "frmTerrainTypes.frx":0010
         TabIndex        =   2
         Top             =   600
         Width           =   1455
      End
      Begin VB.Label lblTileGroups 
         Caption         =   "Tile Groups"
         Height          =   195
         Left            =   240
         TabIndex        =   3
         Top             =   2040
         Width           =   810
      End
      Begin VB.Label lblTerrainType 
         Caption         =   "TerrainType"
         Height          =   195
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   855
      End
   End
   Begin VB.Frame fmePastingMethod 
      Caption         =   "Pasting Method"
      Height          =   615
      Left            =   11640
      TabIndex        =   7
      Top             =   3960
      Width           =   5055
      Begin VB.OptionButton optTile 
         Caption         =   "Tile"
         Height          =   195
         Left            =   2640
         TabIndex        =   9
         Top             =   240
         Width           =   615
      End
      Begin VB.OptionButton optTileGroup 
         Caption         =   "Tile Group"
         Height          =   195
         Left            =   120
         TabIndex        =   8
         Top             =   240
         Value           =   -1  'True
         Width           =   1815
      End
   End
   Begin VB.Frame fmeAttributes 
      Caption         =   "Attributes"
      Height          =   3945
      Left            =   11640
      TabIndex        =   6
      Top             =   0
      Width           =   5055
   End
   Begin VB.PictureBox picPreview 
      Height          =   4575
      Left            =   2040
      ScaleHeight     =   301
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   629
      TabIndex        =   5
      Top             =   0
      Width           =   9495
   End
   Begin VB.PictureBox picDisplay 
      Height          =   7095
      Left            =   2040
      ScaleHeight     =   469
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   973
      TabIndex        =   10
      Top             =   4680
      Width           =   14655
   End
End
Attribute VB_Name = "frmTerrainTypes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Default path
Private Const strPath As String = "\Sierra\Outpost2\Maps\"

' Tile set info
Private Const numTileSetsToLoad As Long = 13
Private tileSetCol As New CTileSetList

' Tile group info
Private tileGroups As New CTileGroupList

' Terrain Type info
Private terrainType() As New CTerrainGroupList

' User interface selections
Private selectedTerrainType As CTerrainGroupList
Private selectedTileGroup As CTileGroup
Private selectedTileX As Long
Private selectedTileY As Long

' Test Map display data
Private mapData() As Long


Private Sub Form_Load()
    Dim i As Long
    Dim lngRetVal As Long
    Dim strFileName As String

    ' Load the tile sets
    lngRetVal = tileSetCol.LoadTileSets(strPath, numTileSetsToLoad)
    ' Check for errors
    If lngRetVal <> numTileSetsToLoad Then
        MsgBox "Error loading tile set well" + Format$(lngRetVal + 1, "0000") + ".bmp", , "Aborting Tile Set Load"
    End If

    
    ' ---------
    ' **DEBUG**
    ' Load the tile group info
    lngRetVal = tileGroups.OpenFile(strPath + "TileGroupInfo")
    ' Check for errors
    If lngRetVal <> 0 Then
        MsgBox "Error loading tile group info", , "Error"
    End If


    ' **DEBUG** Visually compare tiles
    'VisuallyCompareTiles

    ' Sort the Tile Groups into the Terrain Types
    SortTileGroups
    
    ' Allocate space for map data
    ReDim mapData(32, 32)
    ' End DEBUG
    ' ---------

    ' Update the Terrain Type list box
    UpdateTerrainTypeListBox

    ' Set default values
    If lstTerrainType.ListCount > 0 Then lstTerrainType.ListIndex = 0
    If lstTileGroups.ListCount > 0 Then lstTileGroups.ListIndex = 0
End Sub

Private Sub lstTerrainType_Click()
    ' Exit if nothing is selected
    If lstTerrainType.ListIndex < 0 Then Exit Sub

    ' Set the selected terrain group
    Set selectedTerrainType = terrainType(lstTerrainType.ListIndex)

    ' Update the Tile Group list box
    UpdateTileGroupListBox
End Sub

Private Sub lstTileGroups_Click()
    ' Exit if nothing is selected
    If lstTileGroups.ListIndex < 0 Then Exit Sub
    
    ' Set the selected tile group
    Set selectedTileGroup = selectedTerrainType.TileGroup(lstTileGroups.ListIndex)
    
    ' Clip the selected tile coordinates
    If selectedTileX >= selectedTileGroup.Width Then
        selectedTileX = selectedTileGroup.Width - 1
    End If
    If selectedTileY >= selectedTileGroup.Height Then
        selectedTileY = selectedTileGroup.Height - 1
    End If

    ' Update the preview
    picPreview.Refresh
End Sub

Private Sub picDisplay_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim i As Long
    Dim j As Long
    Dim tileX As Long
    Dim tileY As Long

    ' Check if the left mouse button was released
    If Button And vbLeftButton = vbLeftButton Then
        ' Paste to the given location
        tileX = X \ 32
        tileY = Y \ 32
        If optTileGroup.Value Then
            ' Paste a tile group
            For j = 0 To selectedTileGroup.Height - 1
                For i = 0 To selectedTileGroup.Width - 1
                    mapData(tileX + i, tileY + j) = selectedTileGroup.Tile(i, j)
                Next i
            Next j
        ElseIf optTile.Value Then
            ' Paste a tile
            mapData(tileX, tileY) = selectedTileGroup.Tile(selectedTileX, selectedTileY)
        End If
    End If
    
    ' Update the display
    picDisplay_Paint
End Sub

Private Sub picDisplay_Paint()
    Dim i As Long
    Dim j As Long
    Dim TileSet As Long
    Dim tileIndex As Long
    Dim retVal As Long
    Dim currentTileSet As CTileSet

    For j = 0 To UBound(mapData, 2)
        For i = 0 To UBound(mapData, 1)
            ' Convert the global tile index to a (tileSet, tileIndex) pair
            TileSet = tileSetCol.TileSetIndexOfTile(mapData(i, j))
            tileIndex = mapData(i, j) - tileSetCol.NumTilesUpTo(TileSet)
            ' Paste the tile
            Set currentTileSet = tileSetCol.TileSet(TileSet)
            retVal = currentTileSet.Paste(picDisplay.hDC, i * 32, j * 32, tileIndex)
        Next i
    Next j
End Sub

Private Sub picPreview_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Check if the left mouse button was released
    If Button And vbLeftButton = vbLeftButton Then
        If selectedTileX >= 0 And selectedTileY >= 0 Then
            ' Unhighlight the old selection
            picPreview.Line (selectedTileX * 33, selectedTileY * 33)-(selectedTileX * 33 + 33, selectedTileY * 33 + 33), RGB(0, 0, 0), B
        End If
        ' Change the currently selected tile
        selectedTileX = X \ 33
        selectedTileY = Y \ 33
        ' Clip the selected tile to the Tile Group size
        If selectedTileX >= selectedTileGroup.Width Then
            selectedTileX = selectedTileGroup.Width - 1
        End If
        If selectedTileY >= selectedTileGroup.Height Then
            selectedTileY = selectedTileGroup.Height - 1
        End If
        ' Highlight the new selection
        picPreview.Line (selectedTileX * 33, selectedTileY * 33)-(selectedTileX * 33 + 33, selectedTileY * 33 + 33), RGB(255, 0, 0), B
    End If
End Sub

Private Sub picPreview_Paint()
    Dim i As Long
    Dim j As Long
    Dim retVal As Long
    Dim tileIndex As Long
    Dim tileSetIndex As Long
    Dim currentTileSet As CTileSet

    ' Make sure a Tile Group is selected
    If selectedTileGroup Is Nothing Then Exit Sub

    ' Draw the currently selected Tile Group
    For j = 0 To selectedTileGroup.Height - 1
        For i = 0 To selectedTileGroup.Width - 1
            ' Get the tile index
            tileIndex = selectedTileGroup.Tile(i, j)
Debug.Print tileIndex; " ";
            ' Map the tile index into a tile set index and a tile index (within that tile set)
            tileSetIndex = tileSetCol.TileSetIndexOfTile(tileIndex)
            Set currentTileSet = tileSetCol.TileSet(tileSetIndex)
            ' Adjust the index into the correct tile group
            tileIndex = tileIndex - tileSetCol.NumTilesUpTo(tileSetIndex)
'Debug.Print "("; tileSetIndex; ", "; tileIndex; ") ";
            ' Display the tile
            retVal = currentTileSet.Paste(picPreview.hDC, i * 33 + 1, j * 33 + 1, tileIndex)
            ' Check if the tile failed to draw
            If retVal = 0 Then
                ' Draw the default background color over the tile
                picPreview.Line (i * 33 + 1, j * 33 + 1)-(i * 33 + 33, j * 33 + 32), RGB(239, 235, 222), BF
            End If

            ' Draw the border around the tile
            picPreview.Line (i * 33, j * 33)-(i * 33 + 33, j * 33 + 33), RGB(0, 0, 0), B
        Next i
        Debug.Print
    Next j
    Debug.Print
    Debug.Print
    
    ' Highlight the selected tile
    If selectedTileX >= 0 And selectedTileY >= 0 Then
        picPreview.Line (selectedTileX * 33, selectedTileY * 33)-(selectedTileX * 33 + 33, selectedTileY * 33 + 33), RGB(255, 0, 0), B
    End If
End Sub


Private Sub UpdateTerrainTypeListBox()
    Dim i As Long

    ' Clear what's currentlyin the list
    lstTerrainType.Clear

    ' Add the Terrain Types to the list box
    For i = 0 To UBound(terrainType)
        lstTerrainType.AddItem terrainType(i).Name
    Next i
End Sub

Private Sub UpdateTileGroupListBox()
    Dim i As Long

    ' Clear what's currently in the list
    lstTileGroups.Clear

    ' Add the Tile Groups for this terrain type
    For i = 0 To selectedTerrainType.NumTileGroups - 1
        lstTileGroups.AddItem selectedTerrainType.TileGroup(i).Name
    Next i
End Sub


Private Sub SortTileGroups()
    Dim i As Long
    Dim currentTileGroup As CTileGroup
    Dim strName As String
    Dim strPrefix As String

    ' Create space for the terrain type array
    ReDim terrainType(6) As New CTerrainGroupList
    
    ' Set the terrain type names
    terrainType(0).Name = "Rock"
    terrainType(1).Name = "Mud"
    terrainType(2).Name = "Sand"
    terrainType(3).Name = "Snow Transition"
    terrainType(4).Name = "Snow"
    terrainType(5).Name = "Lava"
    terrainType(6).Name = "Blue"

    ' Sort all Tile Groups into Terrain Types
    For i = 0 To tileGroups.NumTileGroups - 1
        ' Get the Tile Group and it's Name
        Set currentTileGroup = tileGroups.Group(i)
        strName = currentTileGroup.Name

        ' Choose which terrain type to place it in
        strPrefix = Left$(strName, 3)
        If strPrefix = "roc" Then
            currentTileGroup.Name = Right$(strName, Len(strName) - 3)
            terrainType(0).AddTileGroup currentTileGroup
        ElseIf strPrefix = "mud" Then
            currentTileGroup.Name = Right$(strName, Len(strName) - 3)
            terrainType(1).AddTileGroup currentTileGroup
        ElseIf strPrefix = "san" Then
            currentTileGroup.Name = Right$(strName, Len(strName) - 3)
            terrainType(2).AddTileGroup currentTileGroup
        ElseIf strPrefix = "snw" Then
            currentTileGroup.Name = Right$(strName, Len(strName) - 3)
            terrainType(3).AddTileGroup currentTileGroup
        ElseIf Left$(strName, 4) = "snow" Then
            currentTileGroup.Name = Right$(strName, Len(strName) - 4)
            terrainType(4).AddTileGroup currentTileGroup
        ElseIf LCase$(Right$(strName, 4)) = "lava" Then
            currentTileGroup.Name = LCase$(Left$(strName, Len(strName) - 5))
            terrainType(5).AddTileGroup currentTileGroup
        ElseIf strName = "BLUE" Then
            currentTileGroup.Name = LCase$(strName)
            terrainType(6).AddTileGroup currentTileGroup
        Else
            Debug.Print "Unplaced Tile Group: "; strName
        End If
    Next i
End Sub



Private Sub VisuallyCompareTiles()
    Dim i As Long
    Dim j As Long
    Dim sourceTileIndex As Long
    Dim destTileIndex As Long
    Dim sourceGroup As CTileGroup
    Dim destGroup As CTileGroup
    
    ' Display group names and indexes
    For i = 0 To 32 ' tileGroups.NumTileGroups - 1
    '    Debug.Print i; " "; tileGroups.Group(i).Name
    Next i

    ' Rock to Mud
    Set sourceGroup = tileGroups.Group(1)   ' Mud Base 1
    Set destGroup = tileGroups.Group(90)    ' Rock to Mud
    For j = 0 To destGroup.Height - 1
        For i = 0 To destGroup.Width - 1
            sourceTileIndex = sourceGroup.Tile(i Mod sourceGroup.Width, j Mod sourceGroup.Height)
            destTileIndex = destGroup.Tile(i, j)
            
            ' Visually compare tiles
            SubtractTiles destTileIndex, sourceTileIndex
        Next i
    Next j
End Sub

' Used to visually compare combined tiles (such as transition tiles, possibly)
Public Sub SubtractTiles(destTileIndex As Long, sourceTileIndex As Long)
    Dim k As Long
    Dim sourceTileSetIndex As Long
    Dim destTileSetIndex As Long
    Dim sourceTileSet As CTileSet
    Dim destTileSet As CTileSet
    Dim sourcePixel As Long
    Dim destPixel As Long
    
    ' Map indexes to (tileSet, tileIndex) pairs
    ' Source
    sourceTileSetIndex = tileSetCol.TileSetIndexOfTile(sourceTileIndex)
    Set sourceTileSet = tileSetCol.TileSet(sourceTileSetIndex)
    sourceTileIndex = sourceTileIndex - tileSetCol.NumTilesUpTo(sourceTileSetIndex)
    
    ' Dest
    destTileSetIndex = tileSetCol.TileSetIndexOfTile(destTileIndex)
    Set destTileSet = tileSetCol.TileSet(destTileSetIndex)
    destTileIndex = destTileIndex - tileSetCol.NumTilesUpTo(destTileSetIndex)
    
    For k = 0 To 1023
        sourcePixel = sourceTileSet.PixelData(destTileIndex, k)
        destPixel = destTileSet.PixelData(sourceTileIndex, k)
        ' **TODO** Try to figure out how colors from one palette map to colors from the other palette
        If sourceTileSet.PalEntry(sourcePixel) = destTileSet.PalEntry(destPixel) Then
            destTileSet.PixelData(destTileIndex, k) = 0
        End If
    Next k
End Sub
